#!/bin/bash 
## oracle 桼ǥץȤ¹ԤƲ

##=============================================================================
## Ƽѿ򥳥ǹԤޤʬδĶˤ碌ѹ
source /etc/bashrc
NLS_LANG=American_America.JA16EUC
ORACLE_TNS=testdb                                   ## tnsnames.ora ǵҤӥ̾ꤹ
ORACLE_SID=testdb                                   ## SID ꤹ
SysIDPW='sys/ѥ as sysdba'                  ## sqlplus  DBA ¤³ݤ ID/PW 
Mailaddress='your@mail.address.jp'                  ## ᡼Υɥ쥹
BackupPoint=(/db/ora)                               ## ֥ǡե.arc, .dbfˤ¸ߤǥ쥯ȥ̾ꡣ
                                                    ## ʣξϥڡƵҤ
Tools_dir=/db/tools/backup                          ## ΥץȤ֤
Log_file=$Tools_dir/fullbackup.log                  ## ե
Backup_dir=/db/tools/backup                         ## Хååץե¸
MachineId=`hostname`                                ## Machine name
##=============================================================================

sleeptime=5
cd $Tools_dir


## BEGIN BLOCK 1 : MODULES=====================================================
## BEGIN BLOCK 1.1 : MailOnErr()-----------------------------------------------
MailOnErr ()
{
    Today=`date '+%Y/%m/%d'`
    Time=`date '+%T'`
    MailTo=$Mailaddress
    echo "===================
$0
$Today
$Time

$MachineId has had an error.
Database: ${ORACLE_TNS}
Massage : $message
===================" | mail -s "Error Mail fullbackup_tool" $MailTo
}
## END BLOCK 1.1---------------------------------------------------------------


## BEGIN BLOCK 1.2 : MailOnGood()----------------------------------------------
MailOnGood ()
{
    Today=`date '+%Y/%m/%d'`
    Time=`date '+%T'`
    MailTo=$Mailaddress
    echo "===================
$0
$Today
$Time

$MachineId backup has completed.
Database: ${ORACLE_TNS}
===================" | mail -s "Oracle full_backup completed" $MailTo
}
## ENDBLOCK 1.2----------------------------------------------------------------


## BEGIN BLOCK 1.3 : log_write()-----------------------------------------------
log_write ()
{
    Today=`date '+%Y/%m/%d'`
    Time=`date '+%T'`
    echo "$Today-$Time              $message" >>$Log_file
}
## ENDBLOCK 1.3----------------------------------------------------------------
## END BLOCK 1 : MODULES=======================================================


message='Begin fullbackup tool'
log_write


## BEGIN BLOCK 2 : ORACLE CHECK================================================
## BEGIN BLOCK 2.1 : Oracle Usable Check---------------------------------------
message='- Oracle Usable Check'
log_write
sqlplus -s <<Eof
    $SysIDPW
    exit
Eof

if [ $? -ne 0 ]
then
    message="Sqlplus could not connect to Oracle. Oracle could not Use!!"
    log_write
    MailOnErr
    exit 1
fi
## END BLOCK 2.1---------------------------------------------------------------


## BEGIN BLOCK 2.2 : The newest Archive redo log is generated------------------
message='- The newest Archive redo log is generated'
log_write
sqlplus -s <<Eof
    $SysIDPW
    alter system switch logfile;
    exit
Eof

if [ $? -ne 0 ]
then
    message="could not switch logfile. Oracle could not Use!!"
    log_write
    MailOnErr
    exit 1
fi
## END BLOCK 2.2---------------------------------------------------------------


## BEGIN BLOCK 2.3 : Get Oracle SID Environmental Variable---------------------
message='- Get Oracle SID Environmental Variable'
log_write
if [ -z "$ORACLE_TNS" ]
then
    message='ERROR occured!
    Can not find $ORACLE_TNS definition - EXITING SCRIPT!'
    log_write
    MailOnErr
    exit 1
fi
## END BLOCK 2.3---------------------------------------------------------------
## END BLOCK 2 : ORACLE CHECK==================================================


## BEGIN BLOCK 3 : Check Database in Archivelog mode and is enabled============
message='- Check Database in Archivelog mode and is enabled'
log_write
sqlplus -s << Eof 2>&1
    $SysIDPW
    spool archiveloglist.txt;
    archive log list
    spool off;
    exit
Eof

if [ ! -s "archiveloglist.txt" ]
then
    message='ERROR occured!
    Failed to produce archive log list.'
    log_write
    MailOnErr
    exit 1
fi

DbLogMode=`awk ' /log mode/ {print $4}' archiveloglist.txt`
if [ -z $DbLogMode ]
then
    message='ERROR occured!
    Can not get Database log mode.'
    log_write
    MailOnErr
    exit 1
fi

if [ "$DbLogMode" != Archive ]
then
    message='ERROR occured!
    Oracle database is not in Database log Mode.
    Please inform your Oracle DBA that the ARCHIVELOG mode must
    be set   - EXIT SCRIPT!'
    log_write
    MailOnErr
    exit 1
fi

AutoArc=`awk ' /Automatic/ {print $3}' archiveloglist.txt`
if [ -z $AutoArc ]
then
    message='ERROR occured!
    Can not get Database archival mode.'
    log_write
    MailOnErr
    exit 1
fi

if [ "$AutoArc" != Enabled ]
then
    message='ERROR occured!
    Oracle database is not in Automatic Archival Mode.
    Please inform your Oracle DBA that the ARCHIVELOG mode must
    be set  - EXIT SCRIPT!'
    log_write
    MailOnErr
    exit 1
fi
## END BLOCK 3=================================================================


## BEGIN BLOCK 4 : Get Oracle Home Environmental Variable======================
message='- Get Oracle Home Environmental Variable'
log_write
if [ -z "$ORACLE_HOME" ]
then
    message='ERROR occured!
    Can not find $ORACLE_HOME definition - EXITING SCRIPT!'
    log_write
    MailOnErr
    exit 1
fi
## END BLOCK 4=================================================================


## BEGIN BLOCK 5 : Get Oracle Initialisation File Path and File================
message='- Get Oracle Initialisation File Path and File'
log_write
sqlplus << Eof 2>&1
    $SysIDPW
    spool spfile.txt;
    select value from v\$system_parameter where name ='spfile';
    spool off;
    exit
Eof

if [ ! -s "spfile.txt" ]
then
    message='ERROR occured!
    Failed to produce spfile location.'
    log_write
    MailOnErr
    exit 1
fi

InitSpFile=`awk '/.ora/ {print $1}' spfile.txt`
if [ -z $DbLogMode ]
then
    message='ERROR occured!
    Can not get spfile location.'
    log_write
    MailOnErr
    exit 1
fi
InitFile=$Backup_dir/init${ORACLE_TNS}.ora
## END BLOCK 5=================================================================


## BEGIN BLOCK 6 : Database Backup=============================================
## BEGIN BLOCK 6.1 : Begin Backup----------------------------------------------
message='- Begin Backup'
log_write
sqlplus << Eof 2>&1
    $SysIDPW
    alter database begin backup;
    exit
Eof
## END BLOCK 6.1---------------------------------------------------------------


## BEGIN BLOCK 6.2 : Compress All Backup All files-----------------------------
message="- Compress all backup-files."
log_write
rm -f datafiles.txt
for dirname in ${BackupPoint[@]};
do
    find $dirname -name *.dbf >>datafiles.txt
    find $dirname -name *.arc >>datafiles.txt
done;

cat datafiles.txt | while read line
do
    compress_file=`echo $line | awk -F/ '{print $NF}'`
    data_file=`echo $line | awk '{print $1}'`

    message="  - compress_file : $compress_file"
    log_write
    tar cvzf $Backup_dir/$compress_file.tar.gz $data_file

    if [ $? -ne 0 ]
    then
        message="ERROR OCCURED!! when $TableSpace : $compress_file copy"
        log_write
        MailOnErr
        exit 1
    fi

    echo "   --> compressed!!"
done;

tar cvfz $Backup_dir/db0.tar.gz /db0/oradata
message="Compress all backup-files."
log_write
## END BLOCK 6.2---------------------------------------------------------------


## BEGIN BLOCK 6.3 : End Backup------------------------------------------------
message='- End Backup'
log_write
sqlplus << Eof 2>&1
    $SysIDPW
    alter database end backup;
    exit
Eof
## END BLOCK 6.3---------------------------------------------------------------
## END BLOCK 6 : End of Database Backup========================================


## BEGIN BLOCK 7 : Configuration File Backup===================================
message='- Configuration File Backup'
log_write
sqlplus << Eof 2>&1
    $SysIDPW
    create pfile='$InitFile' from spfile;
    exit
Eof
## END BLOCK 7=================================================================


## BEGIN BLOCK 8 : Controlfile Backup==========================================
message='- Controlfile Backup'
log_write
sqlplus << Eof 2>&1
    $SysIDPW
    alter database backup controlfile to '$Backup_dir/controlfile.arc' reuse;
    exit
Eof
message="Controlfile Backup Completed."
log_write
## END BLOCK 8=================================================================


## BEGIN BLOCK 9 : Lister & tnsname Backup=====================================
message='- Lister & tnsname Backup'
log_write
cp -f $ORACLE_HOME/network/admin/listener.ora $Backup_dir/listener.ora
cp -f $ORACLE_HOME/network/admin/tnsnames.ora $Backup_dir/tnsnames.ora
## END BLOCK 9=================================================================


MailOnGood
message='END fullbackup tool'
log_write

exit 0
